VERSION 5.00
Begin VB.Form frmPlugin 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00BEBEBE&
   BorderStyle     =   0  'None
   ClientHeight    =   1920
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2955
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H0000FF00&
   HasDC           =   0   'False
   Icon            =   "frmPlugin.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   128
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   197
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   120
      Top             =   240
   End
   Begin VB.Label lblText 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   240
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   975
   End
End
Attribute VB_Name = "frmPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Information about our current counter
Dim hCounter As Long
Dim strName As String
Dim hQuery As Long

' The current level of geeky counters to show in the
' PdhVbGetOneCounterPath dialog box
Dim iPerformanceDetail As PERF_DETAIL

' Our graph array
Dim dat() As Long

' Our color settings
Dim High As Long
Dim Low As Long
Dim Graph As Long
Dim Peak As Long
Dim CurMax As Long
Public Sub ResetDisplay()

    Dim i As Integer
    
    For i = 1 To Me.ScaleWidth - 2
        dat(i) = (Me.ScaleHeight - 2)
    Next i

End Sub
Public Sub RedrawDisplay()
    
    Dim i As Integer
    
    Me.Line (0, 0)-(Me.ScaleWidth - 1, 0), Low
    Me.Line -Step(0, Me.ScaleHeight - 1), High
    Me.Line -Step(-(Me.ScaleWidth - 1), 0), High
    Me.Line -Step(0, -(Me.ScaleHeight - 1)), Low

    For i = 1 To Me.ScaleWidth - 2
        Me.Line (i, 1)-(i, Me.ScaleHeight - 2), Me.BackColor
        Me.Line (i, Me.ScaleHeight - 2)-(i, dat(i)), Graph
        Me.PSet (i, dat(i)), Peak
    Next i

End Sub
Public Function setup()

    Dim temp As String
    Dim pdhStatus As PDH_STATUS

    ' Lets load the color settings
    temp = oServer.GetKey(Me.Tag, "LowColor")
    If temp <> "" Then
        Low = RGB(CByte("&H" & Left(temp, 2)), CByte("&H" & Mid(temp, 3, 2)), CByte("&H" & Right(temp, 2)))
    Else
        Low = vb3DHighlight
    End If
    
    temp = oServer.GetKey(Me.Tag, "HiColor")
    If temp <> "" Then
        High = RGB(CByte("&H" & Left(temp, 2)), CByte("&H" & Mid(temp, 3, 2)), CByte("&H" & Right(temp, 2)))
    Else
        High = vb3DDKShadow
    End If

    temp = oServer.GetKey(Me.Tag, "GraphColor")
    If temp <> "" Then
        Graph = RGB(CByte("&H" & Left(temp, 2)), CByte("&H" & Mid(temp, 3, 2)), CByte("&H" & Right(temp, 2)))
    Else
        Graph = vb3DFace
    End If

    temp = oServer.GetKey(Me.Tag, "PeakColor")
    If temp <> "" Then
        Peak = RGB(CByte("&H" & Left(temp, 2)), CByte("&H" & Mid(temp, 3, 2)), CByte("&H" & Right(temp, 2)))
    Else
        Peak = vb3DFace
    End If
    
    ' Setting up the timer
    temp = oServer.GetKey(Me.Tag, "Interval")
    If temp <> "" Then
        Timer1.Interval = CInt(temp)
    Else
        Timer1.Interval = 1000
    End If
    
    ReDim dat(Me.ScaleWidth - 2)
    
    ' Our users are experts, let them se everything
    iPerformanceDetail = PERF_DETAIL_WIZARD
    
    ' Create the query, and verify that the request succeeded.
    pdhStatus = PdhOpenQuery(0, 1, hQuery)
    If pdhStatus <> 0 Then
        oServer.Execute "!log " & Me.Tag & " Error: OpenQuery failed"
    End If
    
    temp = oServer.GetKey(Me.Tag, "Counter")
    If temp <> "" Then
        SetCounter temp, hQuery
        
        ResetDisplay    ' Clear our display
    
        UpdateValues    ' Force an immediate display of the counter values
    
        ' Now that everything is set up, we can enable the 1 second timer.
        ' It's disabled up to this point.
        Timer1.Enabled = True
    Else
        oServer.Execute "!log No counter specified"
    End If

End Function
'-------------------------------------------------------------
' Calls PdhVbAddCounter, then sets the counter path and
' handle.
'-------------------------------------------------------------
Public Sub SetCounter(strCounterName As String, hQuery As Long)
    
    Dim pdhStatus As PDH_STATUS
    
    ' Associate the counter path to the query
    pdhStatus = PdhVbAddCounter(hQuery, strCounterName, hCounter)
    strName = strCounterName
    
End Sub
'--------------------------------------------------------------
' Displays the values for the selected counter.
'--------------------------------------------------------------
Private Sub UpdateValues()
    
    Dim dblCounterValue As Double
    Dim pdhStatus As Long
    Dim i As Long
    Dim head As String
    Dim tail As String
    Dim temp As String
    Dim maximum As Long
    
    ' Get the most recent value for all the added counters
    PdhCollectQueryData (hQuery)
    
    ' Get the counter value as a double
    dblCounterValue = PdhVbGetDoubleCounterValue(hCounter, pdhStatus)
                
    ' Verify that when we queried, the returned value was valid
    If (pdhStatus = PDH_CSTATUS_VALID_DATA) Or (pdhStatus = PDH_CSTATUS_NEW_DATA) Then
            
        If oServer.evalBool(oServer.GetKey(Me.Tag, "ShowText")) Then
            temp = oServer.GetKey(Me.Tag, "head")
            If temp <> "" Then
                head = temp
            End If
            temp = oServer.GetKey(Me.Tag, "tail")
            If temp <> "" Then
                tail = temp
            End If
            lblText.Caption = head & Format$(dblCounterValue, "0") & tail
        End If

        If oServer.evalBool(oServer.GetKey(Me.Tag, "ShowGraph")) Then
            
            temp = oServer.GetKey(Me.Tag, "maximum")
            If temp <> "" Then
                If LCase(temp) = "auto" Then
                    If dblCounterValue > CurMax Then
                        CurMax = dblCounterValue
                    End If
                    maximum = CurMax
                Else
                    maximum = CLng(temp)
                End If
            Else
                maximum = 100
            End If
    
            For i = 2 To Me.ScaleWidth - 2
                dat(i - 1) = dat(i)
            Next i
            dat(Me.ScaleWidth - 2) = (Me.ScaleHeight - 2) - ((dblCounterValue / maximum) * (Me.ScaleHeight - 2))
            
            Call RedrawDisplay
        End If
    Else
        oServer.Execute "!log " & Me.Tag & " Error: the returned value wasn't valid, it was " & pdhStatus
    End If

End Sub
Private Sub Form_Resize()

    lblText.Width = Me.ScaleWidth
    lblText.Height = Me.ScaleHeight

End Sub
Private Sub Form_Unload(Cancel As Integer)
    
    Timer1.Enabled = False  ' Don't need periodic updates anymore
    PdhCloseQuery (hQuery)  ' Free the query

End Sub
Private Sub lblText_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If Button = 2 Then
    
        Dim cbLen As Long
        Dim strCounterPath As String * 256
        Dim strCounterPath2 As String
        
        ' Display the dialog to pick one counter.  strCounterPath is a buffer
        ' of 256 charaters
        cbLen = PdhVbGetOneCounterPath(strCounterPath, 256, iPerformanceDetail, "core.monitor")
        
        ' If nothing was selected, bail out
        If cbLen = 0 Then Exit Sub
        
        ' Make a string that contains only the valid characters that were written
        ' to by the call to PdhVbGetOneCounterPath
        strCounterPath2 = Left$(strCounterPath, cbLen)
        
        ' Add the new counter to the query, and to the Counters array
        SetCounter strCounterPath2, hQuery
        
        ' Store the new counter in the settings
        oServer.SetKey Me.Tag, "Counter", strCounterPath2
        
        ' Force an immediate display update
        UpdateValues
    
    End If

End Sub
Private Sub Timer1_Timer()
    
    ' Set to trigger once a second.  Update the counter display
    UpdateValues

End Sub
